#include <iostream>
#include <fstream>
#include "Botonera.h"
#include "Constantes.h"

// Constructor
Botonera::Botonera(const string &name) : Atomic(name),
		Habilita_in(addInputPort("Habilita_in")),
		Pedido_in(addInputPort("Pedido_in")),
		Pedido_out(addOutputPort("Pedido_out")) {
}

// Inicializacion
Model& Botonera::initFunction() {

	this->estado = Normal;
	this->Habilitada = false;
	
	return *this;
}

// Funcion de transicion externa
Model& Botonera::externalFunction(const ExternalMessage& msg) {

	if (msg.port() == Pedido_in) {

		if ((Habilitada) && (estado== Normal)) {

			this->estado = EnviandoValor;
			this->ValorPedido = (int) msg.value();
			holdIn(0);
		 
		}
	
	} else 
	
	if (msg.port()==Habilita_in){
	
		if ((int) msg.value() == HABILITAR_BOTONERA) {
			this->Habilitada = true;
			passivate();
		} else
		if ((int) msg.value() == DESHABILITAR_BOTONERA) {
			this->Habilitada = false;
			passivate();
		}
	}
	
	return *this;
}


// Funcion de transicion interna
Model& Botonera::internalFunction(const InternalMessage& msg) {

	switch (this->estado) {
		case EnviandoValor:
			this->estado = Normal;
			break;
		default:
			break;
	}

	passivate();

	return *this;
}

// Funcion de salida
Model& Botonera::outputFunction(const CollectMessage& msg) {

	switch (this->estado) {

		case EnviandoValor:
			cerr << "DEBUG: EnviandoValor en Botonera" << endl;
			sendOutput(msg.time(), Pedido_out, (Value)this->ValorPedido);
			break;

		default:
			break;
	
	}

	return *this;
}

// Funcion holdIn propia
void Botonera::holdIn(const VTime& t) {
	Atomic::holdIn(AtomicState::active, t);
}
