#include <iostream>
#include <fstream>
#include "Display.h"
#include "Constantes.h"

// Constructor
Display::Display(const string &name) : Atomic(name),
		Mensaje_in(addInputPort("Mensaje_in")),
		Mensaje_out(addOutputPort("Mensaje_out")) {
}

// Inicializacion
Model& Display::initFunction() {
	this->estado = MostrandoMensaje;
	this->Mensaje = Inserte_Ficha;

	this->salida = new ofstream(ParallelMainSimulator::Instance().getParameter(description(), "archivo").c_str());

	return *this;
}

// Funcion de transicion externa
Model& Display::externalFunction(const ExternalMessage& msg) {

	if (msg.port() == Mensaje_in) {
		this->Mensaje= (int) msg.value();
		this->estado= ActualizandoMensaje;
		holdIn(0);
	}

	return *this;
}


// Funcion de transicion interna
Model& Display::internalFunction(const InternalMessage& msg) {

	switch (this->estado) {
		case ActualizandoMensaje:
			this->estado=MostrandoMensaje;
			break;

		default:
			break;
	}
	passivate();

	return *this;
}

// Funcion de salida
Model& Display::outputFunction(const CollectMessage& msg) {

	switch (this->estado) {
		case ActualizandoMensaje:
			sendOutput(msg.time(), Mensaje_out, (Value) this->Mensaje);
			switch ((int) this->Mensaje) {
				case 0:
					*salida << "Inserte una ficha" << endl;
					break;
				case 1:
					*salida << "Elija una bebida" << endl;
					break;
				case 2:
					*salida << "Procesando su pedido" << endl;
					break;
				case 3:
					*salida << "Imposible procesar" << endl;
					break;
				case 4:
					*salida << "Retire su vaso" << endl;
					break;
			}
			break;

		default:
			break;
	}

	return *this;
}

// Funcion holdIn propia
void Display::holdIn(const VTime& t) {
	Atomic::holdIn(AtomicState::active, t);
}

