#ifndef __VASOS_H
#define __VASOS_H

#include "atomic.h"


class Vasos : public Atomic {
	public:
		//Constructor
		Vasos(const string &name = "Vasos");
		// Estados
		enum Estado {Normal, UbicandoVaso};

	protected:
		//funciones de transicion externa, interna y de output y de inicializacion
		Model& initFunction();
 		Model& externalFunction(const ExternalMessage&); // externa
		Model& internalFunction(const InternalMessage&); // interna
		Model& outputFunction(const CollectMessage&); // salida
		void holdIn(const VTime&); // holdIn sin la fase, ya que es siempre activa

	private:
		//puertos de entrada
		const Port &PedidoVaso_in;
		
		//puertos de salida
		const Port &Vaso_out;
		const Port &Notif_out;
				
		//variables de estado
		Estado estado;
		
};


#endif __VASOS_H
