/*******************************************************************
*
*  DESCRIPTION: Simulator::registerNewAtomics()
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

#include "pmodeladm.h" 
#include "parsimu.h"
#include "queue.h"      // class Queue
#include "generat.h"    // class Generator
#include "cpu.h"        // class CPU
#include "transduc.h"   // class Transducer
#include "constgenerat.h" //class ConstGenerator

// Expendedora de bebidas calientes
#include "Fichas.h" // class Fichas
#include "Agua.h" // class Agua
#include "Bebida.h" // class Bebida
#include "Vasos.h" // class Vasos
#include "Botonera.h" // class Botonera
#include "Display.h" // class Display
#include "UC.h" // class UC

#ifdef DEVS_AIRPORT
#include "modulo.h"
#include "selector.h"
#include "control.h"
#include "cola.h"
#include "deposito.h"
#include "salida.h"
#endif

#ifdef DEVS_NET
#include "client.h"
#include "controla.h"
#include "disco.h"
#include "multicpu.h"
#include "router.h"
#include "stopq.h"
#include "transduc2.h"
#endif

void ParallelMainSimulator::registerNewAtomics()
{
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<Queue>() , "Queue" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<Generator>() , "Generator" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<ConstGenerator>() , "ConstGenerator" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<CPU>() , "CPU" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<Transducer>() , "Transducer" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<Fichas>() , "Fichas" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<Agua>() , "Agua" ) ;	
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<Bebida>() , "Bebida" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<Vasos>() , "Vasos" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<Botonera>() , "Botonera" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<Display>() , "Display" ) ;
	SingleParallelModelAdm::Instance().registerAtomic( NewAtomicFunction<UC>() , "UC" ) ;
}
